/***************************************************************************/
/* NOTE:                                                                   */
/* This document is copyright (c) by Oz Solomonovich.  All non-commercial  */
/* use is allowed, as long as this document is not altered in any way, and */
/* due credit is given.                                                    */
/***************************************************************************/

// Options.h : header file
//

#if !defined(AFX_OPTIONS_H__23E5E9B8_C14F_11D3_BA8F_0000861DFCE7__INCLUDED_)
#define AFX_OPTIONS_H__23E5E9B8_C14F_11D3_BA8F_0000861DFCE7__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "AutoPropPage.h"


/////////////////////////////////////////////////////////////////////////////
// CFilesPage dialog

class CFilesPage : public CAutoPropPage
{
	DECLARE_DYNCREATE(CFilesPage)

// Construction
public:
	CFilesPage();
	~CFilesPage();

// Dialog Data
	//{{AFX_DATA(CFilesPage)
	enum { IDD = IDD_OPTPAGE_FILES };
	CListBox	m_ExtList;
	//}}AFX_DATA

    CString m_sExtList;


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CFilesPage)
    public:
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	void UpdateConfigList();
	void FillExtList();

    // Generated message map functions
	//{{AFX_MSG(CFilesPage)
	virtual BOOL OnInitDialog();
	afx_msg void OnReset();
	afx_msg int OnVKeyToItem(UINT nKey, CListBox* pListBox, UINT nIndex);
	afx_msg void OnInsertext();
	afx_msg void OnDeleteext();
	afx_msg void OnUndo();
	afx_msg void OnSelChange();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

    CStringList m_StrList;

    enum undo_ops {none, ins, del};

    undo_ops m_LastUndoOp;
    CString  m_sLastUndoVal;
    CWnd *   m_pUndoWnd;

    void DeleteString(CString str);
    void InsertString(CString str);
    void SetLastUndo(undo_ops op, CString val);
};


/////////////////////////////////////////////////////////////////////////////
// COptionsPage dialog

class COptionsPage : public CAutoPropPage
{
	DECLARE_DYNCREATE(COptionsPage)

// Construction
public:
	COptionsPage();
	~COptionsPage();

// Dialog Data
	//{{AFX_DATA(COptionsPage)
	enum { IDD = IDD_OPTPAGE_OPTIONS };
	BOOL	m_bCheckComments;
	BOOL	m_bCountBlanks;
	BOOL	m_bActiveProjOnly;
	//}}AFX_DATA


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(COptionsPage)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(COptionsPage)
	virtual BOOL OnInitDialog();
	afx_msg void DoModified();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


/////////////////////////////////////////////////////////////////////////////
// COptionsSheet

class COptionsSheet : public CHHPropSheet
{
	DECLARE_DYNAMIC(COptionsSheet)

// Construction
public:
	COptionsSheet(CWnd* pParentWnd = NULL, UINT iSelectPage = 0);

// Attributes
public:
    CFilesPage      m_FilesPage;
    COptionsPage    m_OptionsPage;

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(COptionsSheet)
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~COptionsSheet();

	// Generated message map functions
protected:
	//{{AFX_MSG(COptionsSheet)
		// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////



//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_OPTIONS_H__23E5E9B8_C14F_11D3_BA8F_0000861DFCE7__INCLUDED_)
